/**
 * BladeX Commercial License Agreement
 * Copyright (c) 2018-2099, https://bladex.cn. All rights reserved.
 * <p>
 * Use of this software is governed by the Commercial License Agreement
 * obtained after purchasing a license from BladeX.
 * <p>
 * 1. This software is for development use only under a valid license
 * from BladeX.
 * <p>
 * 2. Redistribution of this software's source code to any third party
 * without a commercial license is strictly prohibited.
 * <p>
 * 3. Licensees may copyright their own code but cannot use segments
 * from this software for such purposes. Copyright of this software
 * remains with BladeX.
 * <p>
 * Using this software signifies agreement to this License, and the software
 * must not be used for illegal purposes.
 * <p>
 * THIS SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY. The author is
 * not liable for any claims arising from secondary or illegal development.
 * <p>
 * Author: Chill Zhuang (bladejava@qq.com)
 */
package org.springblade.modules.project.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.apache.ibatis.annotations.Param;
import org.springblade.modules.project.pojo.dto.DataStatDTO;
import org.springblade.modules.project.pojo.dto.ProjectInfoPageDTO;
import org.springblade.modules.project.pojo.entity.ProjectInfo;
import org.springblade.modules.project.pojo.vo.*;
import org.springblade.modules.system.pojo.entity.ApiScope;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.List;

/**
 *  Mapper 接口
 *
 * @author BladeX
 */
public interface ProjectInfoMapper extends BaseMapper<ProjectInfo> {

    ProjectInfoDetailVO detail(@Param("id") Long id);

    ProjectAndPlanDetailVO detail2(Long id);

    List<ProjectInvestPlanVO> getAllPlanByProjectId(@Param("id") Long id);

    List<ProjectPlanProgressVO> getAllProgressByProjectId(@Param("id") Long id);

    PageVO<ProjectInfoVO> page(PageVO<ProjectInfoVO> page,@Param("dto") ProjectInfoPageDTO dto);

    List<DataProjectStatVO2> dataProjectStat(@Param("dto") DataStatDTO dto);

    List<DataInvestStatVO2> dataInvestStat(@Param("dto") DataStatDTO dto);

    List<DataScheduleStatVO2> dataScheduleStat(@Param("dto") DataStatDTO dto);

    LocalDate dataEndDate();

    void deleteWarning();

    List<InvestPlanWarningVO> getAllYearPlan();

    Long getBuildTotal(@Param("dto") ProjectInfoPageDTO dto);

    void deleteProgressByProjectId(@Param("projectId") Long id);

    ProjectInfo getProjectYear();

    BigDecimal getAllYearlyInvestByProjectId(@Param("projectId")Long projectId);

    void updateInvestYearAll(@Param("investYearAll")BigDecimal investYearAll, @Param("projectId")Long projectId);

    List<DataProjectStatVO2> dataProjectStat1(@Param("dto")DataStatDTO dto);

    List<DataInvestStatVO2> dataInvestStat1(@Param("dto")DataStatDTO dto);

    List<DataScheduleStatVO2> dataScheduleStat1(@Param("dto")DataStatDTO dto);
}
